#!/bin/sh
# This script takes a ps file and converts it into an EPS with the proper
# bounding box. It keeps only the first page.

echo | gs -sDEVICE=bbox $1 2>&1 | grep "^..BoundingBox" > $1.info 2>&1
awk -v "info=$1.info" < $1 '
	BEGIN {
		copy = 1
		getline < info
		bb=$0
	}

	/^[%][%]BoundingBox:/ { next } 

	/^[%][!]PS/ { 
		print $0 " EPSF-3.0"
		print bb
		next
	}
	
	/^[%][%]Page: 2/ {copy = 0}

	/^[%][%]Trailer/ {copy = 1} 

	/^[%][%]DocumentMedia:/ {next} 
	
	{
		if (copy == 1)
			print $0
	}
'  > $2

rm -f $1.info
