#include <assert.h>
#include <string.h>
#include "simple.h"
#include DISPLAY

buf_cell_t bufdata[80 * 25];
buf_cell_t *rwptr;
buf_state_t bufstate;
void *bufemu = NULL;

/* display->buffer: set screen dimensions (visible buffer size) */
void buf_set_screen_dim(const int w, const int h)
{
	assert(w == 80);
	assert(h == 25);
}

/* scroll the buffer. bottom line will be filled with 0, default fg/bg/attr */
void buf_scroll(const void *b)
{
	int x;
	buf_cell_t *ptr;

	memmove(bufdata, bufdata + 80, 80 * 24 * sizeof(buf_cell_t));

	ptr = bufdata + 1920;
	for(x=0; x<80; x++) {
		ptr->c = 0;
		ptr->color = bufstate.color;
		ptr++;
	}
	display_scroll();
}

/* invalidate display */
void buf_update(const void *b, const int x1, const int y1, const int x2, const int y2)
{
	display_update(x1, y1, x2, y2);
}

/* erase part of buffer */
void buf_erase(void *b, const int x1, const int y1, const int x2, const int y2)
{
	int x, y;
	for(y=y1; y<=y2; y++) {
		buf_set_rw(b, x1, y);
		for(x=x1; x<=x2; x++)
			buf_write_char(b, 0);
	}

	buf_update(b, x1, y1, x2, y2);
}

