#include "interface.h"
#include "timer.c"

/**
 * register fd for watching
 */
void display_watch(int fd, int wtype, watched_callback_t callback, void *data)
{
	log_printf(3, "now watching fd %d [%p]\n", fd, data);
	assert(numwatched < MAXWATCHED);

	watches[numwatched].fd = fd;
	watches[numwatched].wtype = wtype;
	watches[numwatched].callback = callback;
	watches[numwatched].data = data;
	numwatched ++;
}

/**
 * unregister fd for watching
 */
void display_unwatch(int fd)
{
	int i;

	log_printf(3, "no longer watching fd %d\n", fd);

	for(i=0; i<numwatched; ) {
		if(watches[i].fd == fd) {
			watches[i] = watches[numwatched-1];
			numwatched--;
			continue;
		} else {
			i++;
		}
	}
}

/* handle alt+numpad codes */
static int num_code = 0;
int display_numcode(code)
{
	if ((code < 0) && (num_code > 0)) {
		log_printf(4, "num code release: %d\n", num_code);
		buf_dsp_char(dsp_bf, num_code % 255);
		num_code = 0;
		return 1;
	}
	num_code = num_code * 10 + code;
	return 0;
}
