#define TERM_NAME "dumb"

#ifndef emu_dummy_h
#define emu_dummy_h

#ifdef HAVE_EMULATION
#error Can not have more than one EMULATION module.
#endif

#define HAVE_EMULATION
#include "emulation/interface.h"

#include BUFFER
#include IO
#include DISPLAY

typedef enum {
	DUMMY = 0,
} emu_state_t;

typedef enum {
	NUL = 0x00,
	BEL = 0x07,
	BS  = 0x08,
	HT  = 0x09,
	LF  = 0x0a,
	VT  = 0x0b,
	FF  = 0x0c,
	CR  = 0x0d,
	SO  = 0x0e,
	SI  = 0x0f,
	CAN = 0x18,
	SUB = 0x1a,
	ESC = 0x1b,
	DEL = 0x7f,
} emu_control_char_t;


// emu_control_char_range: 0x00 - 0x1f 

typedef struct {
	emu_state_t es; // esc seq decode state
	void *buf; // buffer
	buf_state_t *bs; // cursor, attrs, size
	void *io;
} emu_dummy_t;

#ifndef CFG_EMULATION_TAB
	#define CFG_EMULATION_TAB 8
#endif

#endif
