#include <stdio.h> // DEBUG
#include <stdlib.h>

#include "linux.h"

#define D(s) log_printf(2, "%s: %s\n", __func__, s)


static inline void emu_scrolldelta(int lines)
{
	D("scrolldelta");
/*
	scrollback_delta += lines;
	schedule_console_callback();
*/
}
// TODO:buf updaterange(start,count)
// TODO:buf insert char


//unsigned char color_table[] = { 0, 4, 2, 6, 1, 5, 3, 7,
//				       8,12,10,14, 9,13,11,15 };

unsigned char color_table[] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12 ,13 ,14, 15};


/* the default colour table, for VGA+ colour systems */
int default_red[] = {0x00,0xaa,0x00,0xaa,0x00,0xaa,0x00,0xaa,
    0x55,0xff,0x55,0xff,0x55,0xff,0x55,0xff};
int default_grn[] = {0x00,0x00,0xaa,0x55,0x00,0x00,0xaa,0xaa,
    0x55,0x55,0xff,0xff,0x55,0x55,0xff,0xff};
int default_blu[] = {0x00,0x00,0x00,0x00,0xaa,0xaa,0xaa,0xaa,
    0x55,0x55,0x55,0x55,0xff,0xff,0xff,0xff};

static void emu_scrup(void *emu, int t, int b, unsigned int nr)
{
	emu_linux_t *e = emu;
	D("");
	if (t + nr >= b) {
		nr = b - t - 1;
	}
	if (b > e->bs->h || t >= b || nr < 1) {
		return;
	}
	log_printf(2, "scrup(%d, %d, %d)\n", t, b, nr);
	log_printf(2, "shift(%d, %d, %d, %d, %d, %d)\n", 0, t+nr, e->bs->w - 1, b, 0, -nr);
	buf_shift(e->buf, 0, t + nr, e->bs->w - 1, b, 0, -nr);
	buf_update(e->buf, 0, t, e->bs->w - 1, b);
	e->need_wrap = 0;
}

static void emu_scrdown(void *emu, int t, int b, unsigned int nr)
{
	emu_linux_t *e = emu;
	D("");
	if (t + nr >= b) {
		nr = b - t - 1;
	}
	if (b > e->bs->h || t >= b || nr < 1) {
		return;
	}
	log_printf(2, "scrdown(%d, %d, %d)\n", t, b, nr);
	log_printf(2, "shift(%d, %d, %d, %d, %d, %d)\n", 0, t, e->bs->w - 1, b - nr, 0, -nr);
	buf_shift(e->buf, 0, t, e->bs->w - 1, b - nr, 0, nr);
	buf_update(e->buf, 0, t, e->bs->w - 1, b);
	e->need_wrap = 0;
}

static void emu_insert_char(void *emu, unsigned int nr)
{
	emu_linux_t *e = emu;
	D("");
	//TODO: x+nr >= w
	log_printf(2, "xy(%d,%d), insert(%d)\n", e->bs->cursor_x, e->bs->cursor_y, nr);
	log_printf(2, "shift(%d, %d, %d, %d, %d, %d)\n",  e->bs->cursor_x, e->bs->cursor_y, e->bs->w - nr -1, e->bs->cursor_y, nr, 0);
	buf_shift(e->buf, e->bs->cursor_x, e->bs->cursor_y, e->bs->w - nr -1, e->bs->cursor_y, nr, 0);
	buf_update(e->buf, e->bs->cursor_x, e->bs->cursor_y, e->bs->w - 1, e->bs->cursor_y);
	e->need_wrap = 0;
}

static void emu_delete_char(void *emu, unsigned int nr)
{
	emu_linux_t *e = emu;
	D("");
	log_printf(2, "xy(%d,%d), delete(%d)\n", e->bs->cursor_x, e->bs->cursor_y, nr);
	log_printf(2, "shift(%d, %d, %d, %d, %d, %d)\n", e->bs->cursor_x + nr, e->bs->cursor_y, e->bs->w - 1, e->bs->cursor_y, -nr, 0);
	buf_shift(e->buf, e->bs->cursor_x + nr, e->bs->cursor_y, e->bs->w - 1, e->bs->cursor_y, -nr, 0);
	buf_update(e->buf, e->bs->cursor_x, e->bs->cursor_y, e->bs->w - 1, e->bs->cursor_y);
	e->need_wrap = 0;
}

static void emu_set_palette(void *emu)
{
	D("");
/*
	WARN_CONSOLE_UNLOCKED();

	if (e->vc_mode != KD_GRAPHICS)
		e->vc_sw->con_set_palette(vc, color_table);
*/
}
/*
static int set_get_cmap(unsigned char __user *arg, int set)
{
    int i, j, k;

    WARN_CONSOLE_UNLOCKED();

    for (i = 0; i < 16; i++)
	if (set) {
	    get_user(default_red[i], arg++);
	    get_user(default_grn[i], arg++);
	    get_user(default_blu[i], arg++);
	} else {
	    put_user(default_red[i], arg++);
	    put_user(default_grn[i], arg++);
	    put_user(default_blu[i], arg++);
	}
    if (set) {
	for (i = 0; i < MAX_NR_CONSOLES; i++)
	    if (vc_cons_allocated(i)) {
		for (j = k = 0; j < 16; j++) {
		    vc_cons[i].d->vc_palette[k++] = default_red[j];
		    vc_cons[i].d->vc_palette[k++] = default_grn[j];
		    vc_cons[i].d->vc_palette[k++] = default_blu[j];
		}
		set_palette(vc_cons[i].d);
	    }
    }
    return 0;
}
*/
/*
 * Load palette into the DAC registers. arg points to a colour
 * map, 3 bytes per colour, 16 colours, range from 0 to 255.
 */
/*
int con_set_cmap(unsigned char __user *arg)
{
	int rc;

	acquire_console_sem();
	rc = set_get_cmap (arg,1);
	release_console_sem();

	return rc;
}

int con_get_cmap(unsigned char __user *arg)
{
	int rc;

	acquire_console_sem();
	rc = set_get_cmap (arg,0);
	release_console_sem();

	return rc;
}
*/
void emu_reset_palette(void *emu)
{
	emu_linux_t *e = emu;
	int j, k;
	for (j=k=0; j<16; j++) {
		e->palette[k++] = default_red[j];
		e->palette[k++] = default_grn[j];
		e->palette[k++] = default_blu[j];
	}
	emu_set_palette(emu);
}

/*
 * gotoxy() must verify all boundaries, because the arguments
 * might also be negative. If the given position is out of
 * bounds, the cursor is placed at the nearest margin.
 */
static void emu_gotoxy(void *emu, int new_x, int new_y)
{
	// TODO: vc_decom (absolute / relative y move), min_y, max_y ?
	int x, y;
	emu_linux_t *e = emu;

	if (new_x < 0)
		x = 0;
	else if (new_x >= e->bs->w)
		x = e->bs->w - 1;
	else
		x = new_x;
	
	if (e->decom) {
		if (new_y < e->top)
			y = e->top;
		else if (new_y >= e->bottom)
			y = e->bottom - 1;
		else
			y = new_y;
	} else {
		if (new_y < 0)
			y = 0;
		else if (new_y >= e->bs->h)
			y = e->bs->h - 1;
		else
			y = new_y;
	}
	buf_set_cursor(e->buf, x, y);
	e->need_wrap = 0;
}

static void emu_gotoxay(void *emu, int new_x, int new_y)
{
	emu_linux_t *e = emu;
	D("decom?");
	emu_gotoxy(emu, new_x, e->decom ? (e->top + new_y) : new_y);
}

void emu_scrollback(void *emu, int lines)
{
	emu_linux_t *e = emu;
	if (!lines)
		lines = e->bs->h / 2;
	D("");
	emu_scrolldelta(-lines);
}

void emu_scrollfront(void *emu, int lines)
{
	emu_linux_t *e = emu;
	if (!lines)
		lines = e->bs->h / 2;
	D("");
	emu_scrolldelta(lines);
}

inline static void emu_lf(void *emu)
{
	emu_linux_t *e = emu;
	if (e->bs->cursor_y + 1 == e->bottom) {
		emu_scrup(emu, e->top, e->bottom, 1);
	} else {
		buf_cursor_down(e->buf);
	}
	e->need_wrap = 0;
}

inline static void emu_ri(void *emu)
{
	emu_linux_t *e = emu;
	D("");
	if (e->bs->cursor_y == e->top) {
		emu_scrdown(emu, e->top, e->bottom, 1);
	} else {
		buf_cursor_up(e->buf);
		//TODO: move left?
	}
	e->need_wrap = 0;
}

static inline void emu_cr(void *emu)
{
	emu_linux_t *e = emu;
	buf_set_cursor(e->buf, 0, e->bs->cursor_y);
	e->need_wrap = 0;
}

static inline void emu_bs(void *emu)
{
	emu_linux_t *e = emu;
	if (e->bs->cursor_x) {
		buf_cursor_left(e->buf);
		e->need_wrap = 0;
	}
}

static inline void emu_del(void *emu)
{
	/* ignored */
}

// TODO:buf
static void emu_csi_J(void *emu, int vpar)
{
	emu_linux_t *e = emu;

	switch (vpar) {
		case 0:	/* erase from cursor to end of display */
			buf_erase(e->buf, e->bs->cursor_x, e->bs->cursor_y, e->bs->w - 1, e->bs->cursor_y);
			if (!buf_cursor_eoc(e->buf)) {
				buf_erase(e->buf, 0, e->bs->cursor_y + 1, e->bs->w - 1, e->bs->h - 1);
			}
			break;
		case 1:	/* erase from start to cursor */
			buf_erase(e->buf, 0, e->bs->cursor_y, e->bs->cursor_x, e->bs->cursor_y);
			if (e->bs->cursor_y > 0) {
				buf_erase(e->buf, 0, 0, e->bs->w - 1, e->bs->cursor_y - 1);
			}
			break;
		case 2: /* erase whole display */
			buf_erase(e->buf, 0, 0, e->bs->w - 1, e->bs->h - 1);
			break;
		default:
			return;
	}
	e->need_wrap = 0;
}

static void emu_csi_K(void *emu, int vpar)
{
	emu_linux_t *e = emu;

	switch (vpar) {
		case 0:	/* erase from cursor to end of line */
			buf_erase(e->buf, e->bs->cursor_x, e->bs->cursor_y, e->bs->w - 1, e->bs->cursor_y);
			break;
		case 1:	/* erase from start of line to cursor */
			buf_erase(e->buf, 0, e->bs->cursor_y, e->bs->cursor_x, e->bs->cursor_y);
			break;
		case 2: /* erase whole line */
			D("erase whole line");
			buf_erase(e->buf, 0, e->bs->cursor_y, e->bs->w - 1, e->bs->cursor_y);
			break;
		default:
			return;
	}
	e->need_wrap = 0;
}

static void emu_csi_X(void *emu, int vpar) /* erase the following vpar positions */
{					  /* not vt100? */
	emu_linux_t *e = emu;
	int i;
	D("csi X");
	if (!vpar)
		vpar++;
	i = e->bs->cursor_x + vpar -1;
	if (i >= e->bs->w) {
		i = e->bs->w;
	}
	buf_erase(e->buf, e->bs->cursor_x, e->bs->cursor_y, i, e->bs->cursor_y);
	e->need_wrap = 0;
}

static void emu_default_attr(void *emu)
{
	emu_linux_t *e = emu;
	e->intensity = 1;
	e->underline = 0;
	e->reverse = 0;
	e->blink = 0;
	e->color = e->default_color;
}

// TODO:buf updateattr(color,intensity,blink,underline,reverse);
static void emu_update_attr(void *emu)
{
	emu_linux_t *e = emu;
	buf_set_fg(e->buf, e->color & 0x0f);
	buf_set_bg(e->buf, (e->color & 0xf0)>>4);
}


/* console_sem is held */
static void emu_csi_m(void *emu)
{
	emu_linux_t *e = emu;
	int i;
	for (i = 0; i <= e->nparam; i++)
		switch (e->param[i]) {
			case 0:	/* all attributes off */
				emu_default_attr(emu);
				break;
			case 1:
				e->intensity = 2;
				break;
			case 2:
				e->intensity = 0;
				break;
			case 4:
				e->underline = 1;
				break;
			case 5:
				e->blink = 1;
				break;
			case 7:
				e->reverse = 1;
				break;
			case 10: /* ANSI X3.64-1979 (SCO-ish?)
				  * Select primary font, don't display
				  * control chars if defined, don't set
				  * bit 8 on output.
				  */
				D("10: ANSI X3.64-1979 (SCO-ish?)");
/*
				e->vc_translate = set_translate(e->vc_charset == 0
						? e->vc_G0_charset
						: e->vc_G1_charset, vc);
*/				e->disp_ctrl = 0;
				e->toggle_meta = 0;
				break;
			case 11: /* ANSI X3.64-1979 (SCO-ish?)
				  * Select first alternate font, lets
				  * chars < 32 be displayed as ROM chars.
				  */
				D("11: ANSI X3.64-1979 (SCO-ish?)");
/*
				e->vc_translate = set_translate(IBMPC_MAP, vc);
*/				e->disp_ctrl = 1;
				e->toggle_meta = 0;
				break;
			case 12: /* ANSI X3.64-1979 (SCO-ish?)
				  * Select second alternate font, toggle
				  * high bit before displaying as ROM char.
				  */
				D("12: ANSI X3.64-1979 (SCO-ish?)");
				
//				e->vc_translate = set_translate(IBMPC_MAP, vc);
				e->disp_ctrl = 1;
				e->toggle_meta = 1;
				break;
			case 21:
			case 22:
				e->intensity = 1;
				break;
			case 24:
				e->underline = 0;
				break;
			case 25:
				e->blink = 0;
				break;
			case 27:
				e->reverse = 0;
				break;
			case 38: /* ANSI X3.64-1979 (SCO-ish?)
				  * Enables underscore, white foreground
				  * with white underscore (Linux - use
				  * default foreground).
				  */
				D("38: ANSI X3.64-1979 (SCO-ish?)");
/*
				e->vc_color = (e->vc_def_color & 0x0f) | (e->vc_color & 0xf0);
				e->vc_underline = 1;
*/
				break;
			case 39: /* ANSI X3.64-1979 (SCO-ish?)
				  * Disable underline option.
				  * Reset colour to default? It did this
				  * before...
				  */
				e->color = (e->default_color & 0x0f) | (e->color & 0xf0);
				e->underline = 0;
				break;
			case 49:
				e->color = (e->default_color & 0xf0) | (e->color & 0x0f);
				break;
			default:
				if (e->param[i] >= 30 && e->param[i] <= 37)
					e->color = color_table[e->param[i] - 30]
						| (e->color & 0xf0);
				else if (e->param[i] >= 40 && e->param[i] <= 47)
					e->color = (color_table[e->param[i] - 40] << 4)
						| (e->color & 0x0f);
				break;
		}
	emu_update_attr(emu);
}

static void emu_respond_string(void *emu, const char *p)
{
	emu_linux_t *e = emu;
	while (*p) {
		io_got_user_input(e->io, *p);
		p++;
	}
//	con_schedule_flip(tty);
}

static void emu_cursor_report(void *emu)
{
	emu_linux_t *e = emu;
	char buf[40];

	sprintf(buf, "\033[%d;%dR", e->bs->cursor_y + (e->decom ? e->top + 1 : 1), e->bs->cursor_x + 1);
	emu_respond_string(emu, buf);
}

static inline void emu_status_report(void *emu)
{
	emu_respond_string(emu, "\033[0n");	/* Terminal ok */
}

#define VT100ID "\033[?1;2c"
#define VT102ID "\033[?6c"
static inline void emu_respond_ID(void *emu)
{
	emu_respond_string(emu, VT102ID);
}

#if 0
void mouse_report(struct tty_struct *tty, int butt, int mrx, int mry)
{
	char buf[8];

	sprintf(buf, "\033[M%c%c%c", (char)(' ' + butt), (char)('!' + mrx),
		(char)('!' + mry));
	respond_string(buf, tty);
}

/* invoked via ioctl(TIOCLINUX) and through set_selection */
int mouse_reporting(void)
{
	return vc_cons[fg_console].d->vc_report_mouse;
}
#endif

/* console_sem is held */
static void emu_set_mode(void *emu, int on_off)
{
	emu_linux_t *e = emu;
	int i;
	
	D("");
	for (i = 0; i <= e->nparam; i++)
		if (e->ques) {
			switch(e->param[i]) {	/* DEC private modes set/reset */
			case 1:			/* Cursor keys send ^[Ox/^[[x */
				D("decckm");
/*
				if (on_off)
					set_kbd(vc, decckm);
				else
					clr_kbd(vc, decckm);
*/
				break;
			case 3:	/* 80/132 mode switch unimplemented */
				e->deccolm = on_off;
#if 0
				vc_resize(deccolm ? 132 : 80, e->vc_rows);
				/* this alone does not suffice; some user mode
				   utility has to change the hardware regs */
#endif
				break;
			case 5:			/* Inverted screen on/off */
				if (e->decscnm != on_off) {
					e->decscnm = on_off;
					D("invert screen");
//					emu_invert_screen(emu, 0, e->vc_screenbuf_size, 0);
//					emu_update_attr(emu);
				}
				break;
			case 6:			/* Origin relative/absolute */
				e->decom = on_off;
				emu_gotoxay(emu, 0, 0);
				break;
			case 7:			/* Autowrap on/off */
				e->decawm = on_off;
				break;
			case 8:			/* Autorepeat on/off */
				D("autorepeat");
/*
				if (on_off)
					set_kbd(vc, decarm);
				else
					clr_kbd(vc, decarm);
*/
				break;
			case 9:
				D("report mouse");
//				e->vc_report_mouse = on_off ? 1 : 0;
				break;
			case 25:		/* Cursor on/off */
				e->deccm = on_off;
				break;
			case 1000:
				D("report mouse");
//				e->vc_report_mouse = on_off ? 2 : 0;
				break;
			}
		} else {
			switch(e->param[i]) {	/* ANSI modes set/reset */
			case 3:			/* Monitor (display ctrls) */
				e->disp_ctrl = on_off;
				break;
			case 4:			/* Insert Mode on/off */
				e->decim = on_off;
				break;
			case 20:		/* Lf, Enter == CrLf/Lf */
				D("CRLF");
/*
				if (on_off)
					set_kbd(vc, lnm);
				else
					clr_kbd(vc, lnm);
*/
				break;
			}
		}
}

/* console_sem is held */
static void emu_setterm_command(void *emu)
{
	emu_linux_t *e = emu;
	D("");
#if 0
	switch(e->vc_par[0]) {
		case 1:	/* set color for underline mode */
			if (e->vc_can_do_color &&
					e->vc_par[1] < 16) {
				e->vc_ulcolor = color_table[e->vc_par[1]];
				if (e->vc_underline)
					update_attr(vc);
			}
			break;
		case 2:	/* set color for half intensity mode */
			if (e->vc_can_do_color &&
					e->vc_par[1] < 16) {
				e->vc_halfcolor = color_table[e->vc_par[1]];
				if (e->vc_intensity == 0)
					update_attr(vc);
			}
			break;
		case 8:	/* store colors as defaults */
			e->vc_def_color = e->vc_attr;
			if (e->vc_hi_font_mask == 0x100)
				e->vc_def_color >>= 1;
			default_attr(vc);
			update_attr(vc);
			break;
		case 9:	/* set blanking interval */
			blankinterval = ((e->vc_par[1] < 60) ? e->vc_par[1] : 60) * 60 * HZ;
			poke_blanked_console();
			break;
		case 10: /* set bell frequency in Hz */
			if (e->vc_npar >= 1)
				e->vc_bell_pitch = e->vc_par[1];
			else
				e->vc_bell_pitch = DEFAULT_BELL_PITCH;
			break;
		case 11: /* set bell duration in msec */
			if (e->vc_npar >= 1)
				e->vc_bell_duration = (e->vc_par[1] < 2000) ?
					e->vc_par[1] * HZ / 1000 : 0;
			else
				e->vc_bell_duration = DEFAULT_BELL_DURATION;
			break;
		case 12: /* bring specified console to the front */
			if (e->vc_par[1] >= 1 && vc_cons_allocated(e->vc_par[1] - 1))
				set_console(e->vc_par[1] - 1);
			break;
		case 13: /* unblank the screen */
			poke_blanked_console();
			break;
		case 14: /* set vesa powerdown interval */
			vesa_off_interval = ((e->vc_par[1] < 60) ? e->vc_par[1] : 60) * 60 * HZ;
			break;
		case 15: /* activate the previous console */
			set_console(last_console);
			break;
	}
#endif
}

/* console_sem is held */
static void emu_csi_at(void *emu, unsigned int nr)
{
	emu_linux_t *e = emu;
	if (nr > e->bs->w - e->bs->cursor_x)
		nr = e->bs->w - e->bs->cursor_x;
	else if (!nr)
		nr = 1;
	emu_insert_char(emu, nr);
}

/* console_sem is held */
static void emu_csi_L(void *emu, unsigned int nr)
{
	emu_linux_t *e = emu;
	if (nr > e->bs->h - e->bs->cursor_y)
		nr = e->bs->h - e->bs->cursor_y;
	else if (!nr)
		nr = 1;
	emu_scrdown(emu, e->bs->cursor_y, e->bottom, nr);
	e->need_wrap = 0;
}

/* console_sem is held */
static void emu_csi_P(void *emu, unsigned int nr)
{
	emu_linux_t *e = emu;
	if (nr > e->bs->w - e->bs->cursor_x)
		nr = e->bs->w - e->bs->cursor_x;
	else if (!nr)
		nr = 1;
	emu_delete_char(emu, nr);
}

/* console_sem is held */
static void emu_csi_M(void *emu, unsigned int nr)
{
	emu_linux_t *e = emu;
	if (nr > e->bs->h - e->bs->cursor_y)
		nr = e->bs->h - e->bs->cursor_y;
	else if (!nr)
		nr = 1;
	emu_scrup(emu, e->bs->cursor_y, e->bottom, nr);
	e->need_wrap = 0;
}

/* console_sem is held (except via vc_init->reset_terminal */
static void emu_save_cur(void *emu)
{
	emu_linux_t *e = emu;
	D("");
	e->s_x = e->bs->cursor_x;
	e->s_y = e->bs->cursor_y;
	e->s_intensity = e->intensity;
	e->s_underline = e->underline;
	e->s_blink = e->blink;
	e->s_reverse = e->reverse;
	e->s_color = e->color;

//	e->vc_s_charset	= e->vc_charset;
//	e->vc_saved_G0		= e->vc_G0_charset;
//	e->vc_saved_G1		= e->vc_G1_charset;
}

/* console_sem is held */
static void emu_restore_cur(void *emu)
{
	emu_linux_t *e = emu;
	D("");
	emu_gotoxy(emu, e->s_x, e->s_y);
	e->intensity	= e->s_intensity;
	e->underline	= e->s_underline;
	e->blink		= e->s_blink;
	e->reverse		= e->s_reverse;
	e->color		= e->s_color;
/*
	e->vc_charset		= e->vc_s_charset;
	e->vc_G0_charset	= e->vc_saved_G0;
	e->vc_G1_charset	= e->vc_saved_G1;
	e->vc_translate	= set_translate(e->vc_charset ? e->vc_G1_charset : e->vc_G0_charset, vc);
*/
	emu_update_attr(emu);
	e->need_wrap = 0;
}

/* console_sem is held (except via vc_init()) */
static void emu_reset_terminal(void *emu, int do_clear)
{
	emu_linux_t *e = emu;
	D("");
	e->top		= 0;
	e->bottom		= e->bs->h;
	e->es		= ESnormal;
	e->ques		= 0;
//	e->translate	= set_translate(LAT1_MAP, vc);
//	e->G0_charset	= LAT1_MAP;
//	e->G1_charset	= GRAF_MAP;
//	e->charset		= 0;
	e->need_wrap	= 0;
//	e->report_mouse	= 0;
//	e->utf		= 0;
//	e->utf_count	= 0;

	e->disp_ctrl	= 0;
	e->toggle_meta	= 0;

	e->decscnm		= 0;
	e->decom		= 0;
	e->decawm		= 1;
	e->deccm		= 1;
	e->decim		= 0;

//	set_kbd(vc, decarm);
//	clr_kbd(vc, decckm);
//	clr_kbd(vc, kbdapplic);
//	clr_kbd(vc, lnm);
//	kbd_table[e->vc_num].lockstate = 0;
//	kbd_table[e->vc_num].slockstate = 0;
//	kbd_table[e->vc_num].ledmode = LED_SHOW_FLAGS;
//	kbd_table[e->vc_num].ledflagstate = kbd_table[e->vc_num].default_ledflagstate;
	/* do not do set_leds here because this causes an endless tasklet loop
	   when the keyboard hasn't been initialized yet */

//	e->vc_cursor_type = CUR_DEFAULT;
//	e->vc_complement_mask = e->vc_s_complement_mask;

	emu_default_attr(emu);
	emu_update_attr(emu);

	e->tab_stop[0]	= 0x01010100;
	e->tab_stop[1]	=
	e->tab_stop[2]	=
	e->tab_stop[3]	=
	e->tab_stop[4]	= 0x01010101;

//	e->bell_pitch = DEFAULT_BELL_PITCH;
//	e->bell_duration = DEFAULT_BELL_DURATION;

	emu_gotoxy(emu, 0, 0);
	emu_save_cur(emu);
	if (do_clear)
		emu_csi_J(emu, 2);
}

/* console_sem is held */
static void emu_do_con_trol(void *emu, emu_char_t c)
{
	emu_linux_t *e = emu;
	int i, j;
	
	/*
	 *  Control characters can be used in the _middle_
	 *  of an escape sequence.
	 */
	switch ((emu_control_char_t)c) {
	case NUL:
		return;
	case BEL:
		display_bell();
		return;
	case BS:
		emu_bs(emu);
		return;
	case HT:
		i = e->bs->cursor_x;
		while (i < e->bs->w - 1) {
			i++;
			if (e->tab_stop[i >> 5] & (1 << (i & 31)))
				break;
		}
		buf_set_cursor(e->buf, i, e->bs->cursor_y);
		return;
	case LF: case VT: case FF:
		emu_lf(emu);
//		if (!is_kbd(vc, lnm))
//			return;
	case CR:
		emu_cr(emu);
		return;
	case SO:
		D("SO");
//		e->vc_charset = 1;
//		e->vc_translate = set_translate(e->vc_G1_charset, vc);
		e->disp_ctrl = 1;
		return;
	case SI:
		D("SI");
//		e->vc_charset = 0;
//		e->vc_translate = set_translate(e->vc_G0_charset, vc);
		e->disp_ctrl = 0;
		return;
	case CAN: case SUB:
		e->es = ESnormal;
		return;
	case ESC:
		e->es = ESesc;
		return;
	case DEL:
		// TODO: rm -rf
		emu_del(emu);
		return;
	case CSI:
		e->es = ESsquare;
		return;
	}
	switch(e->es) {
	case ESesc:
		e->es = ESnormal;
		switch (c) {
		case '[':
			e->es = ESsquare;
			return;
		case ']':
			e->es = ESnonstd;
			return;
		case '%':
			e->es = ESpercent;
			return;
		case 'E':
			emu_cr(emu);
			emu_lf(emu);
			return;
		case 'M':
			emu_ri(emu);
			return;
		case 'D':
			emu_lf(emu);
			return;
		case 'H':
			D("ESC H");
			e->tab_stop[e->bs->cursor_x >> 5] |= (1 << (e->bs->cursor_x & 31));
			return;
		case 'Z':
			emu_respond_ID(emu);
			return;
		case '7':
			emu_save_cur(emu);
			return;
		case '8':
			emu_restore_cur(emu);
			return;
		case '(':
			e->es = ESsetG0;
			return;
		case ')':
			e->es = ESsetG1;
			return;
		case '#':
			e->es = EShash;
			return;
		case 'c':
			emu_reset_terminal(emu, 1);
			return;
		case '>':  /* Numeric keypad */
			D("clear kbd applic mode");
			//clr_kbd(vc, kbdapplic);
			return;
		case '=':  /* Appl. keypad */
			D("set kbd applic mode");
			//set_kbd(vc, kbdapplic);
			return;
		}
		return;
	case ESnonstd:
		if (c=='P') {   /* palette escape sequence */
			for (i = 0; i < NPARAM; i++)
				e->param[i] = 0;
			e->nparam = 0;
			e->es = ESpalette;
			return;
		} else if (c=='R') {   /* reset palette */
			emu_reset_palette(emu);
			e->es = ESnormal;
		} else
			e->es = ESnormal;
		return;
	case ESpalette:
		if ( (c>='0'&&c<='9') || (c>='A'&&c<='F') || (c>='a'&&c<='f') ) {
			e->param[e->nparam++] = (c > '9' ? (c & 0xDF) - 'A' + 10 : c - '0');
			if (e->nparam == 7) {
				i = e->param[0] * 3;
				j = 1;
				e->palette[i] = 16 * e->param[j++];
				e->palette[i++] += e->param[j++];
				e->palette[i] = 16 * e->param[j++];
				e->palette[i++] += e->param[j++];
				e->palette[i] = 16 * e->param[j++];
				e->palette[i] += e->param[j];
				emu_set_palette(emu);
				e->es = ESnormal;
			}
		} else
			e->es = ESnormal;
		return;
	case ESsquare:
		for (i = 0; i < NPARAM; i++)
			e->param[i] = 0;
		e->nparam = 0;
		e->es = ESgetpars;
		if (c == '[') { /* Function key */
			e->es = ESfunckey;
			return;
		}
		e->ques = (c == '?');
		if (e->ques)
			return;
	case ESgetpars:
		if (c == ';' && e->nparam < NPARAM - 1) {
			e->nparam++;
			return;
		} else if (c >= '0' && c <= '9') {
			e->param[e->nparam] *= 10;
			e->param[e->nparam] += c - '0';
			return;
		} else
			e->es = ESgotpars;
	case ESgotpars:
		e->es = ESnormal;
		switch(c) {
		case 'h':
			emu_set_mode(emu, 1);
			return;
		case 'l':
			emu_set_mode(emu, 0);
			return;
		case 'c':
			if (e->ques) {
				D("set cursor type");
/*
				if (e->param[0])
					e->vc_cursor_type = e->vc_par[0] | (e->vc_par[1] << 8) | (e->vc_par[2] << 16);
				else
					e->vc_cursor_type = CUR_DEFAULT;
*/
				return;
			}
			break;
		case 'm':
			if (e->ques) {
				D("clear selection");
/*
				emu_clear_selection();
				if (e->vc_par[0])
					e->vc_complement_mask = e->vc_par[0] << 8 | e->vc_par[1];
				else
					e->vc_complement_mask = e->vc_s_complement_mask;
*/
				return;
			}
			break;
		case 'n':
			if (!e->ques) {
				if (e->param[0] == 5)
					emu_status_report(emu);
				else if (e->param[0] == 6)
					emu_cursor_report(emu);
			}
			return;
		}
		if (e->ques) {
			e->ques = 0;
			return;
		}
		switch(c) {
		// TODO: optimize
		case 'G': case '`':
			if (e->param[0])
				e->param[0]--;
			emu_gotoxy(emu, e->param[0], e->bs->cursor_y);
			return;
		case 'A':
			if (!e->param[0])
				e->param[0]++;
			emu_gotoxy(emu, e->bs->cursor_x, e->bs->cursor_y - e->param[0]);
			return;
		case 'B': case 'e':
			if (!e->param[0])
				e->param[0]++;
			emu_gotoxy(emu, e->bs->cursor_x, e->bs->cursor_y + e->param[0]);
			return;
		case 'C': case 'a':
			if (!e->param[0])
				e->param[0]++;
			emu_gotoxy(emu, e->bs->cursor_x + e->param[0], e->bs->cursor_y);
			return;
		case 'D':
			if (!e->param[0])
				e->param[0]++;
			emu_gotoxy(emu, e->bs->cursor_x - e->param[0], e->bs->cursor_y);
			return;
		case 'E':
			if (!e->param[0])
				e->param[0]++;
			emu_gotoxy(emu, 0, e->bs->cursor_y + e->param[0]);
			return;
		case 'F':
			if (!e->param[0])
				e->param[0]++;
			emu_gotoxy(emu, 0, e->bs->cursor_y - e->param[0]);
			return;
		case 'd':
			if (e->param[0])
				e->param[0]--;
			emu_gotoxay(emu, e->bs->cursor_x ,e->param[0]);
			return;
		case 'H': case 'f':
			if (e->param[0])
				e->param[0]--;
			if (e->param[1])
				e->param[1]--;
			emu_gotoxay(emu, e->param[1], e->param[0]);
			return;
		case 'J':
			emu_csi_J(emu, e->param[0]);
			return;
		case 'K':
			emu_csi_K(emu, e->param[0]);
			return;
		case 'L':
			emu_csi_L(emu, e->param[0]);
			return;
		case 'M':
			emu_csi_M(emu, e->param[0]);
			return;
		case 'P':
			emu_csi_P(emu, e->param[0]);
			return;
		case 'c':
			if (!e->param[0])
				emu_respond_ID(emu);
			return;
		case 'g':
			if (!e->param[0])
				e->tab_stop[e->bs->cursor_x >> 5] &= ~(1 << (e->bs->cursor_x & 31));
			else if (e->param[0] == 3) {
				e->tab_stop[0] =
					e->tab_stop[1] =
					e->tab_stop[2] =
					e->tab_stop[3] =
					e->tab_stop[4] = 0;
			}
			return;
		case 'm':
			emu_csi_m(emu);
			return;
		case 'q': /* DECLL - but only 3 leds */
			/* map 0,1,2,3 to 0,1,2,4 */
			D("leds");
//			if (e->param[0] < 4)
//				setledstate(kbd_table + e->vc_num,
//					    (e->param[0] < 3) ? e->param[0] : 4);
			return;
		case 'r':
			if (!e->param[0])
				e->param[0]++;
			if (!e->param[1])
				e->param[1] = e->bs->h;
			/* Minimum allowed region is 2 lines */
			if (e->param[0] < e->param[1] &&
			    e->param[1] <= e->bs->h) {
				D("rooaaarrrrrrrrrr");
				e->top = e->param[0] - 1;
				e->bottom = e->param[1];
				emu_gotoxay(emu, 0, 0);
			}
			return;
		case 's':
			D("svacur");
			emu_save_cur(emu);
			return;
		case 'u':
			emu_restore_cur(emu);
			return;
		case 'X':
			emu_csi_X(emu, e->param[0]);
			return;
		case '@':
			emu_csi_at(emu, e->param[0]);
			return;
		case ']': /* setterm functions */
			emu_setterm_command(emu);
			return;
		}
		return;
	case ESpercent:
		e->es = ESnormal;
		switch (c) {
		case '@':  /* defined in ISO 2022 */
//			e->vc_utf = 0;
//			return;
		case 'G':  /* prelim official escape code */
		case '8':  /* retained for compatibility */
			D("set/unset utf8");
//			e->vc_utf = 1;
			return;
		}
		return;
	case ESfunckey:
		e->es = ESnormal;
		return;
	case EShash:
		e->es = ESnormal;
		if (c == '8') {
			D("DEC screen alignment test. kludge :-)");
			/* DEC screen alignment test. kludge :-) */
/*
			e->vc_video_erase_char =
				(e->vc_video_erase_char & 0xff00) | 'E';
			emu_csi_J(emu, 2);
			e->vc_video_erase_char =
				(e->vc_video_erase_char & 0xff00) | ' ';
			emu_do_update_region(emu, e->vc_origin, e->vc_screenbuf_size / 2);
*/
		}
		return;
	case ESsetG0:
/*
		if (c == '0')
			e->vc_G0_charset = GRAF_MAP;
		else if (c == 'B')
			e->vc_G0_charset = LAT1_MAP;
		else if (c == 'U')
			e->vc_G0_charset = IBMPC_MAP;
		else if (c == 'K')
			e->vc_G0_charset = USER_MAP;
		if (e->vc_charset == 0)
			e->vc_translate = set_translate(e->vc_G0_charset, vc);
*/
		D("char map G0");
		e->es = ESnormal;
		return;
	case ESsetG1:
/*
		if (c == '0')
			e->vc_G1_charset = GRAF_MAP;
		else if (c == 'B')
			e->vc_G1_charset = LAT1_MAP;
		else if (c == 'U')
			e->vc_G1_charset = IBMPC_MAP;
		else if (c == 'K')
			e->vc_G1_charset = USER_MAP;
		if (e->vc_charset == 1)
			e->vc_translate = set_translate(e->vc_G1_charset, vc);
*/
		D("char map G1");
		e->es = ESnormal;
		return;
	default:
		e->es = ESnormal;
	}
}



//////////////////////////////////////////////////////
//DUMMY
#include <termios.h>

void emu_setup_fd(int fd)
{
	struct termios t;

	printf("GET: %d\n", tcgetattr(fd, &t));	
  t.c_lflag = ISIG | ICANON | ECHO | ECHOE | ECHOK;
	t.c_cflag = ECHO | ICANON | ISIG | ECHOE | ECHOK;
//	cfmakeraw(&t);
	printf("SET: %d\n",tcsetattr(fd, TCSANOW, &t));
}

void *emu_create(void *buf)
{
	emu_linux_t *emu = malloc(sizeof(emu_linux_t));

	if (emu == NULL) {
		return NULL;
	}
	emu->es = ESnormal;
	emu->buf = buf;
	emu->bs = buf_get_state(buf);
	emu->io = io_create(emu);
	emu->ques = 1;
	emu->default_color = 0x07;
	emu_reset_terminal((void *)emu, 1);

	return (void *)emu;
}

void emu_destroy(void *e)
{
	io_destroy(((emu_linux_t *)e)->io);
	free(e);
}

typedef enum emu_write_ret_e {
	emu_scrolled = 1,
	emu_wrapped = 2,
} emu_write_ret_t;

// echo / write non control char
static inline int emu_write_char(void *emu, emu_char_t c)
{
	emu_linux_t *e = emu;
	int flags = 0;
//	log_printf(2, "EMU_WRITE_CHAR('%c' %d), POS: %d %d\n", c, c, emu->bs->cursor_x, emu->bs->cursor_y);
	log_printf(2, "W('%c' %d), POS: %d %d\n", c, c, e->bs->cursor_x, e->bs->cursor_y);
	log_printf(2, "top:%d, bottom:%d, decom:%d\n", e->top, e->bottom, e->decom);
	// TODO: do_con_write
	// translate
	if (e->need_wrap) {
		D("WWWWWWWRRRRRRAAAAAAAAAAPPPPPP");
		emu_cr(emu);
		emu_lf(emu);
	}
	buf_rw_from_cursor(e->buf);
	buf_write_char(e->buf, c);
	if (buf_cursor_eor(e->buf)) {
		e->need_wrap = e->decawm;
	} else {
		buf_cursor_right(e->buf);
		buf_update(e->buf, e->bs->cursor_x - 1, e->bs->cursor_y,  e->bs->cursor_x, e->bs->cursor_y);
	}
	return flags;
}

void emu_dsp_char(void *emu, emu_char_t c) {
	emu_linux_t *e = emu;

	io_got_user_input(e->io, c);
	buf_update(e->buf, e->bs->cursor_x - 1, e->bs->cursor_y,  e->bs->cursor_x + 1, e->bs->cursor_y);
}


void emu_io_char(void *emu, emu_char_t c) {
	emu_linux_t *e = emu;
	if (e->es == ESnormal && c >= 32 && c != DEL && c != CSI) {
		emu_write_char(emu, c);
	}
	emu_do_con_trol(emu, c);
}

void emu_dsp_ctrl(void *emu, ctrl_t ctrl)
{
	emu_linux_t *e = emu;
	io_control(e->io, ctrl);
}

