#include <sys/types.h>
#include <sys/wait.h>
#include <assert.h>
extern void emu_io_char(void *emu, unsigned char c);

static inline void io_got_output(int fd, int rwe, void *data)
{
	int len;
	unsigned char c;
	io_instance_t *i = data;

	while((len = read(i->master, &c, 1)) >= 0) {
		if (len == 0)
			display_exit();
		assert(len == 1);
		emu_io_char(i->emu, c);
	}
}

#ifdef IO_HAVE_SIGNALS
void io_sigchld(int signal)
{
	int status;
	wait(&status);
	display_exit();
}
#endif

#ifdef IO_HAVE_RESIZE
static inline int io_resize(io_instance_t *i)
{
	struct winsize w;
	int r, c;
	int result;

	display_get_size(&r, &c);
	w.ws_row = r;
	w.ws_col = c;
	w.ws_xpixel = 0;
	w.ws_ypixel = 0;
	result = ioctl(i->master, TIOCSWINSZ, &w);
	#ifndef NDEBUG
		log_printf(3, "IOCTL for resize: %d (%d %d)\n", result, w.ws_row, w.ws_col);
	#endif
	return result;
}
#endif
