#include DISPLAY
#include <fcntl.h>
#include <unistd.h>
#include "global.h"

typedef struct io_instance_s {
	void *emu;
	int master;
} io_instance_t;

#include "../io_common.c"

/* Cerate a new IO instance */
static inline io_instance_t *io_create(void *emu) {
	io_instance_t *i;

	i = malloc(sizeof(io_instance_t));
	i->emu = emu;
	i->master = 0;
	fcntl(i->master, F_SETFL, O_NONBLOCK);
	display_watch(i->master, 1, io_got_output, i);
	return i;
}

/* Destroy an IO instance */
static inline void io_destroy(io_instance_t *i)
{
	free(i);
}

/* We got user input to be submitted to the process */
static inline void io_got_user_input(io_instance_t *io, unsigned char data)
{
	putchar(data);
	fflush(stdout);
}

static inline void io_set_shell(char *shell_, char *shell_args_[])
{
}

static inline int io_get_master(io_instance_t *io)
{
	return io->master;
}

static inline void io_control(io_instance_t *i, ctrl_t ctrl) {
}

